#ifndef HP03_H
#define HP03_H
//--------------------------------------------------------------------------------------
#include <avr/io.h>
#include <compat/deprecated.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include "Font.h"
#include "math.h"
#include "I2C_SW.h"


//--------------------------------------------------------------------------------------
#define HP03D_XCLR  PORTB6      //  HP03D_XCLR

//--------------------------------------------------------------------------------------
typedef struct {
  unsigned short c1;
  unsigned short c2;
  unsigned short c3;
  unsigned short c4;
  unsigned short c5;
  unsigned short c6;
  unsigned short c7;
  unsigned char a;
  unsigned char b;
  unsigned char c;
  unsigned char d;
  unsigned short D1;
  unsigned short D2;
} HP03;

typedef struct {
	unsigned short pressure;
	signed short temp;
} HP03_DATA;

//--------------------------------------------------------------------------------------
volatile BYTE Hoehe;        // Hoehe des Standorts
HP03_DATA data;
HP03 hp03;

double DUT, OFFS, SENS;

//--------------------------------------------------------------------------------------
void StartMCLK(void);
void HP03_ReadCoefficients(void);
HP03_DATA hp03_data(void);
unsigned int HP03_ReadTemp(void);
unsigned int HP03_ReadPressure(void);
void CalculatePressTemp(void);
long int Get2_x(unsigned char i);

//--------------------------------------------------------------------------------------
#endif
