//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
#include "Screen.h"
//--------------------------------------------------------------------------------------
unsigned char einer, zehner, hunderter, tausender, zehntel;
unsigned char ch3, ch2, ch1, ch0;

//--------------------------------------------------------------------------------------
void hexword2ascii(unsigned int wh);

//-----------------------------------------------------------------------------
// waehlt einen Screen - je nach Tastendruck
//-----------------------------------------------------------------------------
void DisplayScreen(void)
{
  if (DisplayOnOff) 
  {
    switch (activeScreen)
    {
      case 0:  Screen00();  break;
      case 1:  Screen01();  break;
      case 2:  Screen02();  break;
      case 3:  Screen03();  break;
     default:               break;
    }
  }
}


//-----------------------------------------------------------------------------
// Screen00: Startbildschirm...
//-----------------------------------------------------------------------------
void Screen00(void)
{
WORD Press,Temp;

  WriteStringBig(0,0,"Druck:",0x08);
  Press = data.pressure/0.98;                    // feste Hoehenkorrektur!
  tausender =  Press/10000;
  Press -= tausender*10000;
  hunderter = Press/1000;
  Press -= hunderter*1000;
  zehner = Press/100;
  Press -= zehner*100;
  einer =  Press/10;
  Press -= einer*10;
  zehntel = Press;

  if (tausender>0) { PaintCharBig2(tausender +0x30,1,2,0x0B); }
  else             { PaintCharBig2(' ',1,2,0);                }
  PaintCharBig2(hunderter +0x30,2,2,0x0D);
  PaintCharBig2(zehner    +0x30,3,2,0x0D);
  PaintCharBig2(einer     +0x30,4,2,0x0D);
  PaintCharBig2('.'            ,5,2,0x0D);
  PaintCharBig2(zehntel   +0x30,6,2,0x0D);

  WriteStringBig(0,4,"Temp:",0x08);
  Temp = data.temp;
  zehner=Temp/100;
  einer=(Temp-zehner*100)/10;
  zehntel=(Temp-zehner*100-einer*10);

  PaintCharBig2(zehner +0x30,1,6,0x0D);
  PaintCharBig2(einer  +0x30,2,6,0x0D);
  PaintCharBig2('.'         ,3,6,0x0D);
  PaintCharBig2(zehntel+0x30,4,6,0x0D);
  PaintCharBig2(0x27        ,5,6,0x0D);
  PaintCharBig2('C'         ,6,6,0x0D);
}


//-----------------------------------------------------------------------------
// Screen01:
//-----------------------------------------------------------------------------
void Screen01(void)
{
  hexword2ascii(hp03.c1); WriteString2(0,0,"C1: 0x",14); 
  PaintChar2(ch3,6,0,14); PaintChar2(ch2,7,0,14); PaintChar2(ch1,8,0,14); PaintChar2(ch0,9,0,14);
  hexword2ascii(hp03.c2); WriteString2(0,1,"C2: 0x",14);
  PaintChar2(ch3,6,1,14); PaintChar2(ch2,7,1,14); PaintChar2(ch1,8,1,14); PaintChar2(ch0,9,1,14);
  hexword2ascii(hp03.c3); WriteString2(0,2,"C3: 0x",14);
  PaintChar2(ch3,6,2,14); PaintChar2(ch2,7,2,14); PaintChar2(ch1,8,2,14); PaintChar2(ch0,9,2,14);
  hexword2ascii(hp03.c4); WriteString2(0,3,"C4: 0x",14);
  PaintChar2(ch3,6,3,14); PaintChar2(ch2,7,3,14); PaintChar2(ch1,8,3,14); PaintChar2(ch0,9,3,14);
  hexword2ascii(hp03.c5); WriteString2(0,4,"C5: 0x",14);
  PaintChar2(ch3,6,4,14); PaintChar2(ch2,7,4,14); PaintChar2(ch1,8,4,14); PaintChar2(ch0,9,4,14);
  hexword2ascii(hp03.c6); WriteString2(0,5,"C6: 0x",14);
  PaintChar2(ch3,6,5,14); PaintChar2(ch2,7,5,14); PaintChar2(ch1,8,5,14); PaintChar2(ch0,9,5,14);
  hexword2ascii(hp03.c7); WriteString2(0,6,"C7: 0x",14);
  PaintChar2(ch3,6,6,14); PaintChar2(ch2,7,6,14); PaintChar2(ch1,8,6,14); PaintChar2(ch0,9,6,14);

  hexword2ascii(hp03.a);  WriteString2(0, 7,"A:0x",14); PaintChar2(ch1,4,7,14);  PaintChar2(ch0,5,7,14);
  hexword2ascii(hp03.b);  WriteString2(7, 7,"B:0x",14); PaintChar2(ch1,11,7,14); PaintChar2(ch0,12,7,14);
  hexword2ascii(hp03.c);  WriteString2(0, 8,"C:0x",14); PaintChar2(ch1,4,8,14);  PaintChar2(ch0,5,8,14);
  hexword2ascii(hp03.d);  WriteString2(7, 8,"D:0x",14); PaintChar2(ch1,11,8,14); PaintChar2(ch0,12,8,14);

  hexword2ascii(hp03.D1);  WriteString2(0,10,"D1: 0x",14);
  PaintChar2(ch3,6,10,14); PaintChar2(ch2,7,10,14); PaintChar2(ch1,8,10,14); PaintChar2(ch0,9,10,14);

  hexword2ascii(hp03.D2);  WriteString2(0,11,"D2: 0x",14);
  PaintChar2(ch3,6,11,14); PaintChar2(ch2,7,11,14); PaintChar2(ch1,8,11,14); PaintChar2(ch0,9,11,14);
}


//-----------------------------------------------------------------------------
// Screen02:
//-----------------------------------------------------------------------------
void Screen02(void) 
{
WORD Press;

    WriteStringBig(0,0,"DruckNN:",0x08);
    Press = data.pressure;
    tausender =  Press/10000;
    Press -= tausender*10000;
    hunderter = Press/1000;
    Press -= hunderter*1000;
    zehner = Press/100;
    Press -= zehner*100;
    einer =  Press/10;
    Press -= einer*10;
    zehntel = Press;

    PaintCharBig2(tausender +0x30,1,2,0x0B);
    PaintCharBig2(hunderter +0x30,2,2,0x0B);
    PaintCharBig2(zehner    +0x30,3,2,0x0B);
    PaintCharBig2(einer     +0x30,4,2,0x0B);
    PaintCharBig2('.'            ,5,2,0x0B);
    PaintCharBig2(zehntel   +0x30,6,2,0x0B);

    WriteStringBig(0,4,"Hoehe:",0x08);
    tausender = Hoehe/100;
    Hoehe -= tausender*100;
    hunderter = Hoehe/10;
    Hoehe -= hunderter*10;
    zehner = Hoehe/1;
    einer = 0;
    if (tausender>0) PaintCharBig2(tausender +0x30,1,6,0x0B);
    else PaintCharBig2(' ',1,6,0x0B);
    PaintCharBig2(hunderter +0x30,2,6,0x0B);
    PaintCharBig2(zehner    +0x30,3,6,0x0B);
    PaintCharBig2(einer     +0x30,4,6,0x0B);
    PaintCharBig2('m'            ,5,6,0x0B);
}

//-----------------------------------------------------------------------------
// Screen03:
//-----------------------------------------------------------------------------
void Screen03(void) 
{
    WriteStringBig(0,0,"Screen 3:",0x08);
}


//-----------------------------------------------------------------------------
// Wandlung HexWord nach Ascii (ch3..ch0) Bsp: 0xAB12 --> 0x41,0x42,0x31,0x32
//-----------------------------------------------------------------------------
void hexword2ascii(unsigned int wh)
{
  ch3 = wh>>12;
  ch2 = (wh>>8) & 0x000F;
  ch1 = (wh>>4) & 0x000F;
  ch0 = wh & 0x000F;

  if (ch3>9) { ch3 = ch3+0x37; }
  else       { ch3 = ch3+0x30; }

  if (ch2>9) { ch2 = ch2+0x37; }
  else       { ch2 = ch2+0x30; }

  if (ch1>9) { ch1 = ch1+0x37; }
  else       { ch1 = ch1+0x30; }

  if (ch0>9) { ch0 = ch0+0x37; }
  else       { ch0 = ch0+0x30; }
}


//----------------------------------------------------------------------------------------
//                      E n d   o f   S c r e e n . c 
//----------------------------------------------------------------------------------------
